
#include <iostream>

#include "Instantiation_and_registry.h"
#include "ASIO_device.h"

int ask_for_device(std::string query) {
    const int num_devices = ASIO_SDK::get_num_ASIO_drivers();
    std::wstring* names = new std::wstring[num_devices];
    ASIO_SDK::read_driver_name_all(names);

    int index = 0;
    std::wstring* name = &names[0];
    while (index++ - num_devices)
        std::wcout << index << ": " << *name++ << std::endl;
    std::cout << index << ": [EXIT]" << std::endl;
	std::cout << query << std::endl;

	std::string s;
	std::cin >> s;
	long ans = strtol(s.c_str(), nullptr, 0);
	if (ans <= 0 || ans > num_devices + 1) {
		std::cout << "Did not understand the input." << std::endl;
		return -1;
	}

	if (ans == index)
		return -2;

    return (int) ans - 1;
}

int main() {
    // Choose devices
    int device_index_1 = -1;
    int device_index_2 = -1;

    while (device_index_1 == -1)
        device_index_1 = ask_for_device("Choose the first ASIO driver");
    if (device_index_1 == -2)
        return 0;
    
    while (device_index_2 == -1)
       device_index_2 = ask_for_device("Choose the second ASIO driver");
    if (device_index_2 == -2)
        return 0;
    
    // Create instances
    IASIO* device_1 = ASIO_SDK::createInstance(device_index_1);
    IASIO* device_2 = ASIO_SDK::createInstance(device_index_2);

    // Initialize devices
	DWORD processID = GetCurrentProcessId();
	ASIOError aerr_1 = device_1->init((void*)&processID);
	ASIOError aerr_2 = device_2->init((void*)&processID);

    // Open respective control panels
    device_1->controlPanel();
    device_2->controlPanel();

    // Exit
    device_1->Release();
    device_2->Release();
    return 0;
}