
#include "ASIO_driver_interface.h"
#include "ASIO_device.h"

class ASIO_Aggregate : private AudioHost {
public:
    ASIO_Aggregate(const int device_index_1, const int device_index_2, AudioHost& host);
    ~ASIO_Aggregate();

    const ASIODevice& get_device_1() { return device_1; };
    const ASIODevice& get_device_2() { return device_2; };

private:
    ASIODevice device_1;
    ASIODevice device_2;
    AudioHost& host;

    void		bufferSwitch(long doubleBufferIndex, bool directProcess, ASIODevice* caller);
	void		sampleRateDidChange(long sampleRate, ASIODevice* caller);
	long		asioMessage(long selector, long value, void* message, double* opt, ASIODevice* caller);
	ASIOTime*   bufferSwitchTimeInfo(ASIOTime* params, long doubleBufferIndex, bool directProcess, ASIODevice* caller);
	bool        device_reset_init(ASIODevice* caller) { return true; };
	void        device_reset_end(ASIODevice* caller) { return; } ;
};