
/*
#pragma once

#include <stdint.h>
#include "CutMasker.h"

class SampleJumper : public CutMasker {
public:
    /// @brief Creates a new instance of SampleJumper. 
    /// @param hardware_buffersize The size of the buffer shared between this software and the devices' driver. It represents the largest amount of samples expected to be sent to both writeNext and readNext.
    /// This value decides the size of the internal buffer, and directly impact the resulting delay. 
    SampleJumper(const int16_t& hardware_buffersize);
    ~SampleJumper();

    void writeNext(int16_t samples_jumped, const int32_t* &source,      const uint16_t &count);
    void readNext (int16_t samples_jumped,       int32_t* &destination, const uint16_t &count);

    void set_threshold_volume(const float  decibels_0DBFS);
    void set_max_sample_jump(const int32_t  sample_val_threshold);

private:
    int32_t* buffer;
    int32_t* temp_buffer;
    uint16_t buffersize;
    uint16_t buffersize_in_bytes;
    uint16_t hardware_buffersize;
    uint16_t hardware_buffersize_in_bytes;

    uint16_t  read_cursor;
    uint16_t write_cursor;
    bool roundtrip;
    bool ignore_xruns;
    int16_t threshold_min;
    int16_t threshold_max;

    int16_t samples_offset;
    int32_t sample_diff_threshold;
    bool faster_consumer; // True means that the audio consumer has a faster clock than the provider, and that this SampleJumper has to delay the signal by one buffer.

    static const int32_t sample_0dBFS = 2147483647;
    static const int32_t SAMPLE_SIZE = sizeof(int32_t);

    void  read_cursor_inc();
    void write_cursor_inc();
    void  read_cursor_inc(const uint16_t& inc);
    void write_cursor_inc(const uint16_t& inc);

    uint16_t try_compress(const uint16_t& num_samples);
    uint16_t try_lengthen(const uint16_t& num_samples);

    uint16_t get_cursor_distance() const ;
    uint16_t MOVE();
};

*/