
#include <stdint.h>
#include <chrono>

#ifndef SAMPLE
#define SAMPLE int32_t
#endif
#ifndef INDEX
#define INDEX int
#endif



class TimeStretcher {
protected:
    INDEX target; // The amount of samples to stretch.

    SAMPLE value_threshold;
    INDEX action_interval;

    INDEX last_sample_popped;
    std::pair<INDEX, SAMPLE>* analysis_buffer;
    INDEX analysis_buffer_size;

    static const SAMPLE SAMPLE_MAX = std::numeric_limits<SAMPLE>::max();

    INDEX remove_elements(SAMPLE* arr, std::pair<INDEX, SAMPLE>* indices, const size_t& size_arr, const size_t& size_indices);

public:

    TimeStretcher(const INDEX& expected_buffersize);

    void set_volume_threshold(const float  decibels_0DBFS);
    void set_value_threshold(const SAMPLE sample_val_threshold);

    void set_action_interval(INDEX num_samples);
    void set_action_interval(std::chrono::microseconds, INDEX samplerate);

    void set_target(INDEX target);
    void add_to_target(INDEX target_addition);
    
    INDEX stretch(SAMPLE* destination, SAMPLE* source, INDEX size);
};

#undef SAMPLE
#undef INDEX