
#pragma once

#include <stdint.h>
#include <mutex>


class Sine {
public:
    Sine(const float& freq, const int& samplerate);
    Sine(const float& freq, const int& samplerate, const int32_t& amplitude);

    void get_data(int32_t* dst, const int sample_count, const int offset) const;

    const int& get_frequency() const { return frequency; };
    const int& get_sample_rate() const { return samplerate; };
    const int& get_data_size() const { return data_size; };

private:
    int32_t* data;
    const int data_size;

    const int samplerate;
    const float frequency;
};