
#pragma once

#include "ASIO_Aggregate.h"
#include "Instantiation_and_registry.h"
#include "ASIO_callback_registry.h"


ASIO_Aggregate::ASIO_Aggregate(int dev1, int dev2, AudioHost& host) : host(host) {
    if (dev1 == dev2)
        throw std::invalid_argument("Cannot create an aggregate device from two instances of the same device");
    
    this->device_1 = ASIODevice(dev1, this, false);
    this->device_2 = ASIODevice(dev2, this, false);
}

// TODO: Fix reset orders
// TODO: Make common 

ASIO_Aggregate::~ASIO_Aggregate() {
    device_1.~ASIODevice();
    device_2.~ASIODevice();
}

void ASIO_Aggregate::bufferSwitch(long doubleBufferIndex, bool directProcess, ASIODevice* caller) {


    host.bufferSwitch(doubleBufferIndex, directProcess, caller);
}

void ASIO_Aggregate::sampleRateDidChange(long sampleRate, ASIODevice* caller) {
    host.sampleRateDidChange(sampleRate, caller);
}

long ASIO_Aggregate::asioMessage(long selector, long value, void* message, double* opt, ASIODevice* caller) {
    return host.asioMessage(selector, value, message, opt, caller);
}

ASIOTime* ASIO_Aggregate::bufferSwitchTimeInfo(ASIOTime* params, long doubleBufferIndex, bool directProcess, ASIODevice* caller) {
    return host.bufferSwitchTimeInfo(params, doubleBufferIndex, directProcess, caller);
}