#include "ASIO_callback_registry.h"



ASIO_callback_registry_entry* ASIO_callback_registry::entries[MAX_SIMULTANEOUS_ASIO_DEVICES];



int ASIO_callback_registry::getAvailableIndex() {
	int index = -1;

	for (int i = 0; i < MAX_SIMULTANEOUS_ASIO_DEVICES; i++) {
		if (!entries[i]) {
			index = i;
			break;
		}
	}

	return index;
}



int ASIO_callback_registry::registerEntry(ASIO_callback_registry_entry* entry) {
	int index = getAvailableIndex();
	if (index < 0)
		return index;

	entries[index] = entry;

	return index;
}



void ASIO_callback_registry::removeEntry(int index) {
	if (index < 0)
		return;

	entries[index] = 0;
}



#define SET_CALLBACK(asiocb, index) asiocb->bufferSwitch = &bufferSwitch_##index; asiocb->bufferSwitchTimeInfo = &bufferSwitchTimeInfo_##index; asiocb->asioMessage = &asioMessage_##index; asiocb->sampleRateDidChange = &sampleRateDidChange_##index;

void ASIO_callback_registry::getCallbackPointers(int index, ASIOCallbacks* result) {
	switch (index) {
	case  0: SET_CALLBACK(result,  0); break;
	case  1: SET_CALLBACK(result,  1); break;
	case  2: SET_CALLBACK(result,  2); break;
	case  3: SET_CALLBACK(result,  3); break;
	case  4: SET_CALLBACK(result,  4); break;
	case  5: SET_CALLBACK(result,  5); break;
	case  6: SET_CALLBACK(result,  6); break;
	case  7: SET_CALLBACK(result,  7); break;
	case  8: SET_CALLBACK(result,  8); break;
	case  9: SET_CALLBACK(result,  9); break;
	case 10: SET_CALLBACK(result, 10); break;
	case 11: SET_CALLBACK(result, 11); break;
	case 12: SET_CALLBACK(result, 12); break;
	case 13: SET_CALLBACK(result, 13); break;
	case 14: SET_CALLBACK(result, 14); break;
	case 15: SET_CALLBACK(result, 15); break;
	case 16: SET_CALLBACK(result, 16); break;
	case 17: SET_CALLBACK(result, 17); break;
	case 18: SET_CALLBACK(result, 18); break;
	case 19: SET_CALLBACK(result, 19); break;
	case 20: SET_CALLBACK(result, 20); break;
	case 21: SET_CALLBACK(result, 21); break;
	case 22: SET_CALLBACK(result, 22); break;
	case 23: SET_CALLBACK(result, 23); break;
	case 24: SET_CALLBACK(result, 24); break;
	case 25: SET_CALLBACK(result, 25); break;
	case 26: SET_CALLBACK(result, 26); break;
	case 27: SET_CALLBACK(result, 27); break;
	case 28: SET_CALLBACK(result, 28); break;
	case 29: SET_CALLBACK(result, 29); break;
	case 30: SET_CALLBACK(result, 30); break;
	case 31: SET_CALLBACK(result, 31); break;
	}
}

#undef SET_CALLBACK