
#include <math.h>
#include "audiotools/Sine.h"

#ifndef PI
#define PI 3.14159265
#endif

const int32_t top = (std::numeric_limits<int32_t>::max)() / (1 << 16);
void sineWave(const float& hz, const int32_t& amplitude, int32_t* buffer, const int& buffer_size, const int& sampleRate, long samplePos) {
	for (int i = 0; i < buffer_size; i++) {
		buffer[i] = amplitude * sin((PI * 2 * samplePos * hz) / sampleRate);
		samplePos++;
	}
}

int main() {
    int frequency = 4;
    int samplerate = 44100;
    const int data_amount_c = 44100;
    const int offset_c = data_amount_c / 100;
    int data_amount = data_amount_c;
    int offset = offset_c;

    int32_t expected[data_amount_c];
    sineWave(frequency, top, expected, data_amount_c, samplerate, offset_c);

    int32_t actual[data_amount_c];
    Sine s(frequency, samplerate, top);
    s.get_data(actual, data_amount, offset);

    for (int i = 0; i < data_amount_c; i++)
        if (actual[i] != expected[i])
            return 1;

    return 0;
}